

///////////////////////////////////////////////////////////////////////////
//
//
//	ALIEN TERMINATOR
//
// 	by Pawelek Biernacki
//
//	Krakow 02-03.1995
//
///////////////////////////////////////////////////////////////////////////

#include <iostream.h>


#include <string.h>
#include <conio.h>
#include <math.h>
#include <dos.h>
#include <malloc.h>
#include <stdlib.h>
#include <time.h>
#include <ctype.h>

#include "mypalet.h"
#include "obraz.h"

/* by Pawelek Biernacki */

unsigned char far *murek=NULL,*glowacz1=NULL,*glowacz2=NULL,*lufa=NULL,
		*ogien=NULL,*rana[3],*alfabet=NULL,*terminal=NULL;
unsigned murek_off,murek_seg,potwor_off,potwor_seg,
	glowacz1_off,glowacz1_seg,glowacz2_off,glowacz2_seg,
	alf_off,alf_seg,ter_off,ter_seg;

unsigned char far *bufor;
/* bufor na ktorym sa przeprowadzane operacje graficzne,
   po ich wykonaniu bufor jest kopiowany na ekran.
   szerokosc bufora - 192 punkty
*/

unsigned bufor_off,bufor_seg;

unsigned wysbuf=160;

int jest_bufor=0;

void alokuj_bufor(void)
{
 unsigned ilosc;
 ilosc=192; // ilosc punktow w linii poziomej bufora
 ilosc*=wysbuf; // wysokosc
 bufor=(unsigned char far *)farmalloc(ilosc);
 if (bufor!=NULL) jest_bufor=1;

 bufor_seg=FP_SEG(bufor);
 bufor_off=FP_OFF(bufor);
}



struct punkt;


int getmaxx(void) { return 192; }
int getmaxy(void) { return 159; }

void putpixel(unsigned x,unsigned y,int kolor)
{ pokeb(0xa000,x+y*320,kolor); }

int getpixel(unsigned x,unsigned y)
{ return peekb(0xa000,x+y*320); }

const wysokosc_sciany=1200; // wysokosc scianki ( pionowa rozdzielczosc )
const wysokosc_potwora=900;
const wysokosc_termin=300;
int xekr=95; // 2*xekr - szerokosc ekranu obserwatora
int yekr=79; // 2*yekr - wysokosc ekranu

// przy korzystaniu z bufora ( dla unikniecia migania )
// wielkosc 2*xekr okresla szerokosc bufora

int ax,ay,bx,by,sy,maxx,maxy;


float h=3.14159/180;
struct { long x,y; } kierunki[72],barki[72];
// tablica w ktorej przechowywane sa wektory kierunku ruchu
int direct=0;
int dokladnosc=64,dokbit=6;

int wzor_wys_anim;

#define wzormin 0
#define wzormax 64
#define oppmin 0
#define oppmax 32


struct wektor
	{
	long x,y,z;
	wektor(long nx,long ny,long nz)
	 { x=nx << dokbit; y=ny << dokbit; z=nz << dokbit; }
	wektor(void) {}
	wektor(punkt &a,punkt &b);
	wektor operator *(long a)
	{ return wektor((x*a)>>dokbit,(y*a)>>dokbit,(z*a)>>dokbit); }
	};

struct punkt
	{
	long x,y,z;
	punkt(void) {}
	punkt(long nx,long ny,long nz)
	 { x=nx<<dokbit; y=ny<<dokbit; z=nz<<dokbit; }
	wektor operator -(punkt &b)
	 { return wektor(x-b.x,y-b.y,z-b.z); }
	void operator +=(wektor &t)
	 { x+=t.x; y+=t.y; z+=t.z; }
	void operator -=(wektor &t)
	 { x-=t.x; y-=t.y; z-=t.z; }
	};

wektor::wektor(punkt &a,punkt &b)
{
 x=b.x-a.x; y=b.y-a.y; z=b.z-a.z;
}

// rog ekranu - punkt P (px,py,pz)
// oko - punkt E (ex,ey,ez)
// zal. pz=ez

#define OKO 100
punkt E(0,-1000,0),P;
wektor PA,PE,zwrot,bok;

wektor nowe_pa[72],nowe_pe[72],nowy_zwrot[72],nowy_bok[72];

int polwys_sciany=wysokosc_sciany/2;
int polwys_potwora=wysokosc_potwora/2;
int polwys_termin=wysokosc_termin/2;
long WK,WKwys_sciany,WKwys_potwora,WKwys_terminala;


long TWKwys_sciany[72],TWKwys_potwora[72],TWKwys_terminala[72];




void oblicz_wektory(void)
{
 int i,t;
 for (i=0;i<72;i++)
  {
   kierunki[i].x=cos(h*i*5)*dokladnosc;
   kierunki[i].y=sin(h*i*5)*dokladnosc;
   barki[i].x=kierunki[i].x<<6;
   barki[i].y=kierunki[i].y<<6;
   nowe_pa[i].x=kierunki[i].x>>1;
   nowe_pa[i].y=kierunki[i].y>>1;


  }



  for (i=0;i<72;i++)
  {
  t=i-18;
   if (t<0) t+=72;
   nowe_pe[i].x=kierunki[t].x*OKO;
   nowe_pe[i].y=kierunki[t].y*OKO;

  t=i+18;
  if (t>71) t-=72;
  nowy_zwrot[i].x=kierunki[t].x*100;
  nowy_zwrot[i].y=kierunki[t].y*100;


   WK=nowe_pa[i].x*nowe_pe[i].y-nowe_pe[i].x*nowe_pa[i].y;
   TWKwys_sciany[i]=(WK*polwys_sciany)>>dokbit;
   TWKwys_potwora[i]=(WK*polwys_potwora)>>dokbit;
   TWKwys_terminala[i]=(WK*polwys_termin)>>dokbit;
  }

  for (i=0;i<72;i++)
  {
  t=i+18;
  if (t>71) t-=72;
  nowy_bok[i]=nowy_zwrot[t];
  }
}





long WXN,WN,WXM,WM;
int YN,YM,XN,XM;


#define wzor_wys_bit 4
	// definicja rowniez w module HANDLER !!!

int szerokosc=wzormax-wzormin;
// parametr okreslajacy ile jest kolumn ze wzoru znajdujacego sie na scianie
// miedzy punktami N i M . "szerokosc" normalnie ma wartosc stala,
// zmienia sie, jezeli scianka zostala obcieta do wymiarow okna
int PN=wzormin,PM=wzormax;
// zmienne okreslajace progi - numery kolumn ze wzoru, ktore sa widoczne
// na sciance ( z uwzglednieniem obciecia )




int faza=0,dfaza=1;


punkt przeciecie(punkt &N,punkt &M,int &kolumna,int kierunek);
void obetnij_z_lewej(int &x1,int &y1,int &x2,int &y2);
void obetnij_z_prawej(int &x1,int &y1,int &x2,int &y2);
void paint_wall(void);
void paint_monster(void);
void scianka(punkt &N,punkt &M);
void opponent(punkt &N,punkt &M);
void rysuj_terminal(punkt &N,punkt &M);


unsigned luf_off,luf_seg;
unsigned luf_wys=192*125+80;

unsigned ogien_off,ogien_seg;
unsigned ogien_poz=192*121+80;

unsigned rana_off[3],rana_seg[3];

unsigned linia_strzalu;

int strzal=0;
int trafiony;


void skrec(void)
{
PA=nowe_pa[direct];
PE=nowe_pe[direct];
P=E; P-=PE;
zwrot=nowy_zwrot[direct];
bok=nowy_bok[direct];
WKwys_sciany=TWKwys_sciany[direct];
WKwys_potwora=TWKwys_potwora[direct];
WKwys_terminala=TWKwys_terminala[direct];
}


#define KOMNATA 1200
#define DRZWI 200
#define SCHOWEK 400

long limit=64l*1050l;
// limit jest obliczony dla konkretnie rozmieszczonych scian,
// dodatkowo zalezy od parametru "dokladnosc"
// sciany musza byc rozmieszczone symetrycznie ( kwadrat o srodku 0,0 )

long lastlimit=63l*KOMNATA;
// granica po ktorej nastepuje przejscie do drugiej komnaty

long limdrzwi=64l*100l;
long otwieraj=64l*600l; // polowa boku kwadratu
			// wspolsrodkowego z komnatu
			// ktory okresla jakie drzwi
			// moga zostac otwarte

long slimit=64l*250l;
long slastlimit=63l*SCHOWEK;

#define BOK 0
// offset wzoru graficznego - bokow scian z otwartymi drzwiami

int Nw,Ew,Sw,Ww,
    W1,W2,W3,
    przesun,otwarte;


int labx=0,laby=0;

// niektore pokoje zamiast normalnych scian zlozone sa z czterech
// oddzielonych od siebie malych pomieszczen
// sa to magazyny, laboratoria, windy itp.

class heya
	{
	private:
	enum { normalna, mala } typ_komnaty;
	int walls[4];
	public:
	heya(void) { typ_komnaty=normalna; }
	void set_walls(int n,int e,int s,int w)
	 { walls[0]=n; walls[1]=e; walls[2]=s; walls[3]=w; }
	void small(void) { typ_komnaty=mala; }
	void come_in(void);
	int open_door(int);
	} meikyu[2][2];

void prepare_meikyu(void)
{
 meikyu[0][0].set_walls(0,1,1,0);

 meikyu[1][0].set_walls(0,0,0,1);
 meikyu[1][0].small();

 meikyu[0][1].set_walls(1,1,0,0);
 meikyu[0][1].small();

 meikyu[1][1].set_walls(0,2,2,1);
}

int heya::open_door(int kierunek)
{
 heya *sasiad;
 int duzy;

 otwarte=0;
 if (kierunek)
  if (walls[kierunek-1]==1) // jesli w tej scianie sa drzwi
	{
	switch (kierunek)
	 {
	 case 1 :
		sasiad=&meikyu[labx][laby-1];
		W1=sasiad->walls[3] << przesun;
		W2=sasiad->walls[0] << przesun;
		W3=sasiad->walls[1] << przesun;
		otwarte=1;
		break;
	 case 2 :
		sasiad=&meikyu[labx+1][laby];
		W1=sasiad->walls[0] << przesun;
		W2=sasiad->walls[1] << przesun;
		W3=sasiad->walls[2] << przesun;
		otwarte=2;
		break;
	 case 3 :
		sasiad=&meikyu[labx][laby+1];
		W1=sasiad->walls[1] << przesun;
		W2=sasiad->walls[2] << przesun;
		W3=sasiad->walls[3] << przesun;
		otwarte=3;
		break;
	 case 4 :
		sasiad=&meikyu[labx-1][laby];
		W1=sasiad->walls[2] << przesun;
		W2=sasiad->walls[3] << przesun;
		W3=sasiad->walls[0] << przesun;
		otwarte=4;
		break;
	 }
	 duzy=(sasiad->typ_komnaty==normalna);
	}
  return duzy;
}

void heya::come_in(void)
{
	Nw=walls[0]<<przesun;
	Ew=walls[1]<<przesun;
	Sw=walls[2]<<przesun;
	Ww=walls[3]<<przesun;
}



int sasiad=1;
// zmienna, ktorej wartosc 0 oznacza ze sasiednia komnata
// jest mala, wartosc 1 oznacza, ze jest duza
int wyjdz;

void w_schowku(void);


// w funkcji "granice" sprawdza sie przy wyjsciu z komnaty, czy nastepna
// komnata nie jest tzw. "mala komnata" ( schowkiem, winda itp. )
// jezeli tak jest - wowczas zamiast normalnej petli gry skacze sie
// do petli "w_schowku", w ktorej jest stosowana inna funkcja "granice',
// oraz inna funkcja dobierania scian.
// przy wyjsciu z petli "w_schowku" ustawiane sa odpowiednie parametry
// ( sciany, potworki itp. )
void granice(void)
{
 switch (otwarte)
 {
 case 0 :
	if (E.x>limit) E.x=limit; else if (E.x<-limit) E.x=-limit;
	if (E.y>limit) E.y=limit; else if (E.y<-limit) E.y=-limit;
	break;

 case 1 : // otwarte drzwi na polnoc
	if (E.x>limit) E.x=limit; else if (E.x<-limit) E.x=-limit;
	if (E.y<-limit) E.y=-limit; else
		if (E.y>limit)
			{
			if ((E.x<limdrzwi) && (E.x>-limdrzwi))
				{
				if (E.y>lastlimit)
				 {
				 E.y=-lastlimit; laby--;
				 meikyu[labx][laby].come_in();
				 meikyu[labx][laby].open_door(3);
				 }
				}
			else E.y=limit;
			}
	break;

 case 2 : // otwarte drzwi na wschod
	if (E.y>limit) E.y=limit; else if (E.y<-limit) E.y=-limit;
	if (E.x<-limit) E.x=-limit; else
		if (E.x>limit)
			{
			if ((E.y<limdrzwi) && (E.y>-limdrzwi))
				{
				if (E.x>lastlimit)
				 {
				 if (sasiad)
				  { // wejscie do duzej komnaty
				  E.x=-lastlimit; labx++;
				  meikyu[labx][laby].come_in();
				  meikyu[labx][laby].open_door(4);
				  }
				  else
				  { // wejscie do malej komnaty
				  wyjdz=0;
				  E.x=-slimit; labx++;
				  meikyu[labx][laby].come_in();
				  meikyu[labx][laby].open_door(4);
				  P=E; P-=PE;
				  w_schowku();
				  E.x=lastlimit; labx--;
				  meikyu[labx][laby].come_in();
				  meikyu[labx][laby].open_door(2);
				  }
				 }
				}
			else E.x=limit;
			}
	break;

 case 3 : // otwarte drzwi na poludnie
	if (E.x>limit) E.x=limit; else if (E.x<-limit) E.x=-limit;
	if (E.y>limit) E.y=limit; else
		if (E.y<-limit)
			{
			if ((E.x<limdrzwi) && (E.x>-limdrzwi))
				{
				if (E.y<-lastlimit)
				 {
				 if (sasiad)
				  { // wejscie do duzej komnaty
				  E.y=lastlimit; laby++;
				  meikyu[labx][laby].come_in();
				  meikyu[labx][laby].open_door(1);
				  }
				  else
				  { // wejscie do malej komnaty
				  wyjdz=0;
				  E.y=slimit; laby++;
				  meikyu[labx][laby].come_in();
				  meikyu[labx][laby].open_door(1);
				  P=E; P-=PE;
				  w_schowku();
				  E.y=-lastlimit; laby--;
				  meikyu[labx][laby].come_in();
				  meikyu[labx][laby].open_door(3);
				  }
				 }
				}
			else E.y=-limit;
			}
	break;

 case 4 : // otwarte drzwi na zachod
	if (E.y>limit) E.y=limit; else if (E.y<-limit) E.y=-limit;
	if (E.x>limit) E.x=limit; else
		if (E.x<-limit)
			{
			if ((E.y<limdrzwi) && (E.y>-limdrzwi))
				{
				if (E.x<-lastlimit)
				 {
				 E.x=lastlimit; labx--;
				 meikyu[labx][laby].come_in();
				 meikyu[labx][laby].open_door(2);
				 }
				}
			else E.x=-limit;
			}
	break;

 }
 P=E; P-=PE;
}


// w tej funkcji ograniczenia zaleza od tego, z ktorej
// strony weszlismy do komnaty - schowek ma prostokatny ksztalt
void mala_granice(void)
{
 switch (otwarte)
 {
 case 0 :
	if (E.x>slimit) E.x=slimit; else if (E.x<-slimit) E.x=-slimit;
	if (E.y>slimit) E.y=slimit; else if (E.y<-slimit) E.y=-slimit;
	break;

 case 1 : // otwarte drzwi na polnoc
	if (E.x>slimit) E.x=slimit; else if (E.x<-slimit) E.x=-slimit;
	if (E.y<-slimit) E.y=-slimit; else
		if (E.y>slimit)
			{
			if ((E.x<limdrzwi) && (E.x>-limdrzwi))
				{
				if (E.y>slastlimit)
				 wyjdz=1;
				}
			else E.y=slimit;
			}
	break;

 case 2 : // otwarte drzwi na wschod
	if (E.y>slimit) E.y=slimit; else if (E.y<-slimit) E.y=-slimit;
	if (E.x<-slimit) E.x=-slimit; else
		if (E.x>slimit)
			{
			if ((E.y<limdrzwi) && (E.y>-limdrzwi))
				{
				if (E.x>slastlimit)
				 wyjdz=1;
				}
			else E.x=slimit;
			}
	break;

 case 3 : // otwarte drzwi na poludnie
	if (E.x>slimit) E.x=slimit; else if (E.x<-slimit) E.x=-slimit;
	if (E.y>slimit) E.y=slimit; else
		if (E.y<-slimit)
			{
			if ((E.x<limdrzwi) && (E.x>-limdrzwi))
				{
				if (E.y<-slastlimit)
				 wyjdz=1;
				}
			else E.y=-slimit;
			}
	break;

 case 4 : // otwarte drzwi na zachod
	if (E.y>slimit) E.y=slimit; else if (E.y<-slimit) E.y=-slimit;
	if (E.x>slimit) E.x=slimit; else
		if (E.x<-slimit)
			{
			if ((E.y<limdrzwi) && (E.y>-limdrzwi))
				{
				if (E.x<-slastlimit)
				 wyjdz=1;
				}
			else E.x=-slimit;
			}
	break;

 }
 P=E; P-=PE;
}


//************************************************************

unsigned char kolor_ziemi=8,kolor_nieba=0;

extern void copy1920(void),copy1632(void);

unsigned pierwszy_punkt=320*8+64;

void bufor_na_ekran(void)
{
  asm {
  push ax
  push bx
  push cx
  push dx
  push ds
  push si
  push es
  push di


  mov di,pierwszy_punkt
  mov si,bufor_off

  mov ax,0xa000
  mov es,ax
  mov ax,bufor_seg
  mov ds,ax

  cld

  mov dx,0

  }
  petla_y:

  #include "movsw.cpp"

  asm {

  add di,320-192

  inc dx
  cmp dx,159
  jne petla_y

  pop di
  pop es
  pop si
  pop ds
  pop dx
  pop cx
  pop bx
  pop ax

   }

}




#define IL_POT 3
// maksymalna ilosc potworow

punkt 	A(-KOMNATA,KOMNATA,0),B(KOMNATA,KOMNATA,0),
	C(KOMNATA,-KOMNATA,0),D(-KOMNATA,-KOMNATA,0),

	// rogi sasiednich komnat - widzianych przez drzwi
	A1(-KOMNATA,3*KOMNATA,0),B1(KOMNATA,3*KOMNATA,0),
	B2(3*KOMNATA,KOMNATA,0),C2(3*KOMNATA,-KOMNATA,0),
	C3(KOMNATA,-3*KOMNATA,0),D3(-KOMNATA,-3*KOMNATA,0),
	D4(-3*KOMNATA,-KOMNATA,0),A4(-3*KOMNATA,KOMNATA,0),

	// krawedzie scian przy otwartych drzwiach
	AAB(-DRZWI,KOMNATA,0),ABB(DRZWI,KOMNATA,0),
	BBC(KOMNATA,DRZWI,0),BCC(KOMNATA,-DRZWI,0),
	CCD(DRZWI,-KOMNATA,0),CDD(-DRZWI,-KOMNATA,0),
	DDA(-KOMNATA,-DRZWI,0),DAA(-KOMNATA,DRZWI,0),

	// punkty malych komnat ( schowkow, wind ) widziane
	// z innej komnaty
	SAAB(-SCHOWEK,KOMNATA,0),SABB(SCHOWEK,KOMNATA,0),
	TAAB(-SCHOWEK,KOMNATA+SCHOWEK*2,0),TABB(SCHOWEK,KOMNATA+SCHOWEK*2,0),
	SBBC(KOMNATA,SCHOWEK,0),SBCC(KOMNATA,-SCHOWEK,0),
	TBBC(KOMNATA+SCHOWEK*2,SCHOWEK,0),TBCC(KOMNATA+SCHOWEK*2,-SCHOWEK,0),
	SCCD(SCHOWEK,-KOMNATA,0),SCDD(-SCHOWEK,-KOMNATA,0),
	TCCD(SCHOWEK,-KOMNATA-SCHOWEK*2,0),TCDD(-SCHOWEK,-KOMNATA-SCHOWEK*2,0),
	SDDA(-KOMNATA,-SCHOWEK,0),SDAA(-KOMNATA,SCHOWEK,0),
	TDDA(-KOMNATA-SCHOWEK*2,-SCHOWEK,0),TDAA(-KOMNATA*2-SCHOWEK,SCHOWEK,0),

	// punkty malych komnat widziane od wewnatrz
	MA(-SCHOWEK,SCHOWEK,0),MB(SCHOWEK,SCHOWEK,0),
	MC(SCHOWEK,-SCHOWEK,0),MD(-SCHOWEK,-SCHOWEK,0),

	MAAB(-DRZWI,SCHOWEK,0),MABB(DRZWI,SCHOWEK,0),
	MBBC(SCHOWEK,DRZWI,0),MBCC(SCHOWEK,-DRZWI,0),
	MCCD(DRZWI,-SCHOWEK,0),MCDD(-DRZWI,-SCHOWEK,0),
	MDDA(-SCHOWEK,-DRZWI,0),MDAA(-SCHOWEK,DRZWI,0),

	// punkty normalnej komnaty widzianej z malej komnaty
	MA4(-SCHOWEK-KOMNATA*2,KOMNATA,0),
	MB4(-SCHOWEK,KOMNATA,0),
	MD4(-SCHOWEK-KOMNATA*2,-KOMNATA,0),
	MC4(-SCHOWEK,-KOMNATA,0),

	MA1(-KOMNATA,SCHOWEK+KOMNATA*2,0),
	MB1(KOMNATA,SCHOWEK+KOMNATA*2,0),
	MD1(-KOMNATA,SCHOWEK,0),
	MC1(KOMNATA,SCHOWEK,0),

	MA2(SCHOWEK,KOMNATA,0),
	MB2(SCHOWEK+KOMNATA*2,KOMNATA,0),
	MD2(SCHOWEK,-KOMNATA,0),
	MC2(SCHOWEK+KOMNATA*2,-KOMNATA,0),

	MA3(-KOMNATA,-SCHOWEK,0),
	MB3(KOMNATA,-SCHOWEK,0),
	MD3(-KOMNATA,-SCHOWEK-KOMNATA*2,0),
	MC3(KOMNATA,-SCHOWEK-KOMNATA*2,0),


      PL(0,0,0),PR(0,0,0),
      potwor[IL_POT], // potworki znajdujace sie w komnacie
      potwor2[IL_POT], // potworki znajdujace sie w sasiedniej komnacie
      T1(-100,KOMNATA,0),T2(100,KOMNATA,0);

long krok=dokladnosc<<4;
long dystans=dokladnosc*250;
// przeciwnik jest ustawiony zawsze prostopadle do gracza

int ruchomy=0;
int akt_il_pot=IL_POT;
// aktualna ilosc potworow - zminia sie w miare, jak potwory sa zabijane
// ustawiane przy wejsciu do komnaty

int 	power[IL_POT], // energia potworow w danej komnacie
	power2[IL_POT]; // energia potworow w sasiedniej komnacie

long roznica_x[IL_POT],roznica_y[IL_POT];
long krok_x[IL_POT],krok_y[IL_POT];


void ustaw_przeciwnika(int numer)
{
punkt &przeciwnik=potwor[numer];
long dx,dy,tooi=2;


dx=barki[direct].x; dy=barki[direct].y;
// dystans do ktorego dazy potwor

	PL.x=przeciwnik.x+dx;
	PL.y=przeciwnik.y+dy;
	PR.x=przeciwnik.x-dx;
	PR.y=przeciwnik.y-dy;

// potwor usiluje zlapac gracza
if (roznica_x[numer]>dystans)
{
przeciwnik.x+=krok_x[numer];
}
else tooi=1;


if (roznica_y[numer]>dystans)
{
przeciwnik.y+=krok_y[numer];
}
else if (tooi==1) sound(100);

}

#define TIME 9
int koniec=0,turn=0,go=0,side=0;
int czas_s=0,czas_g=0,czas_t=0;


void narysuj_przeciwnika(void)
{
if (faza==1)
	 opponent(PR,PL);
	 else
	 opponent(PL,PR);
}


long odleglosc[IL_POT];

void narysuj_obiekt(unsigned of,unsigned sg,unsigned w);

void przygotuj_bufor(void)
{
 unsigned x,y;
 for (x=0;x<192;x++)
  for (y=157;y<159;y++)
   bufor[y*192+x]=0;
}



unsigned char far *napis=NULL;
unsigned napis_off,napis_seg;
unsigned napis_poz=192*40;
int jest_napis=0;
#define napis_dlug 24


void ustaw_napis(char *tekst)
{
 unsigned a=0,litera,x,y;
 while (tekst[a])
  {
   if (tekst[a]!=' ')
   {
    if (tekst[a]=='#') litera='Z'-'A'+1; else litera=tekst[a]-'A';
   for (x=0;x<8;x++)
    for (y=0;y<8;y++)
     pokeb(napis_seg,napis_off+4+a*8+napis_dlug*8*y+x,
	peekb(alf_seg,alf_off+4+litera*8+x+y*('Z'-'A'+3)*8));
    }
    a++;
  }
}

void wyczysc_napis(void)
{
unsigned x,y;
for (x=0;x<napis_dlug*8;x++)
for (y=0;y<8;y++)
pokeb(napis_seg,napis_off+4+x+y*napis_dlug*8,0);
}

void zmien_napis(int wyjscie,int modulo)
{
unsigned x,y,k;
for (x=0;x<napis_dlug*8;x++)
for (y=0;y<8;y++)
 {
k=peekb(napis_seg,napis_off+4+x+y*napis_dlug*8);
if (k) k=wyjscie+k%modulo;
pokeb(napis_seg,napis_off+4+x+y*napis_dlug*8,k);
 }
}

void outtextxy(unsigned xt,unsigned yt,char *tekst)
{
unsigned a=0,litera,x,y;
 while (tekst[a])
  {
   if (tekst[a]!=' ')
   {
   litera=tekst[a]-'A';
   for (x=0;x<8;x++)
    for (y=0;y<8;y++)
     pokeb(0xa000,a*8+320*(y+yt)+x+xt,
	peekb(alf_seg,alf_off+4+litera*8+x+y*('Z'-'A'+3)*8));
    }
    a++;
  }
}


void okienko(int x1,int y1,int x2,int y2,int ramka)
{
unsigned x,y,r;

for (x=x1;x<=x2;x++)
for (y=y1;y<=y2;y++)
putpixel(x,y,0);

for (r=0;r<ramka;r++)
{
 for (x=x1-r;x<=x2+r;x++)
  {
  putpixel(x,y1-1-r,31-r);
  putpixel(x,y2+1+r,31-r);
  }
 for (y=y1-r-1;y<=y2+r+1;y++)
  {
  putpixel(x1-1-r,y,31-r);
  putpixel(x2+1+r,y,31-r);
  }

}

}

void przygotuj_ekran(void)
{
 unsigned x,y;

 for (x=0;x<32;x++)
  setcolorrgb(128+x,0,x*2,0); // redefinicja trzydziestu dwoch kolorow

  setcolorrgb(64,0,0,63);

 for (x=1;x<16;x++)
  setcolorrgb(64+x,32+x*2,0,0);

 for (x=0;x<320;x++)
  for (y=8;y<200;y++)
   putpixel(x,y,25);

 for (x=0;x<16;x++)
  for (y=0;y<160+x;y++)
   {
   putpixel(63-x,8+y,16+x);
   putpixel(64+192+x,8+y,16+x);
   }

 for (y=0;y<16;y++)
  for (x=63-y;x<=64+192+y;x++)
   putpixel(x,7+160+y,16+y);


 okienko(8,60,8+31,150,8);
 okienko(64+192+16+8,60,64+192+31+16+8,150,8);

   outtextxy(0,0,"ALIEN TERMINATOR    BY PAWELEK BIERNACKI");

   outtextxy(8,40,"AMMO");
   outtextxy(64+192+16,40,"ENERGY");

}


// komputer
class computer
	{
	protected:
	char komenda[30];
	int wiersz,kolumna;
	int ilosc_wierszy,ilosc_kolumn,x_res,y_res;

	int kolor;

	static char *cyfry[];
	static char *funkcje[];

	public:
	computer(void) { ilosc_wierszy=15; ilosc_kolumn=22; }
	void start(void) { wiersz=0; kolumna=0; }
	void gotoxy(int x,int y) { wiersz=x; kolumna=y; }
	void writeln(void) { wiersz++; kolumna=0; }
	void writeln(char *tekst) { write(tekst); writeln(); }
	virtual void write(char *tekst)
		{
		if (wiersz<ilosc_wierszy)
			{
		wyczysc_napis();
		ustaw_napis(tekst);
		zmien_napis(128+16,16);
		narysuj_obiekt(napis_off,
			napis_seg,192*(8+wiersz*8)+8+kolumna*8);
		bufor_na_ekran();
		kolumna+=strlen(tekst);
			}
		}

	virtual void plot(int x,int y)
		{
		pokeb(bufor_seg,bufor_off+x+(y+8)*napis_dlug*8+8,kolor);
		}

	virtual void setcolor(int nk)
		{ kolor=128+((nk>0) ? 16+(nk % 16) : 0); }
	virtual void show_screen(void)
		{
		bufor_na_ekran();
		}
	void picture(void);
	int command(void);
	void run(void);
	} brain;



class alien_terminal : public computer
	{
	public:
	alien_terminal(void) { ilosc_wierszy=8; ilosc_kolumn=16; }
	void write(char *tekst);
	void plot(int x,int y)
		{
		pokeb(ter_seg,ter_off+x+y*128,kolor);
		}
	void setcolor(int nk) { kolor=64+(nk%16); }
	void show_screen(void)
		{
		rysuj_terminal(T1,T2);
		narysuj_obiekt(luf_off,luf_seg,luf_wys+384);
		bufor_na_ekran();
		}
	} alien_term;

void alien_terminal::write(char *tekst)
{
unsigned a=0,litera,x,y;
	if (wiersz<ilosc_wierszy)
		{
	while (tekst[a])
	{
		if (tekst[a]!=' ')
		{
	if (tekst[a]=='#') litera='Z'-'A'+1; else litera=tekst[a]-'A';
		for (x=0;x<8;x++)
		for (y=0;y<8;y++)
		pokeb(ter_seg,ter_off+a*8+128*(y+wiersz*8)+x+kolumna*8,
		peekb(alf_seg,alf_off+4+litera*8+x+y*('Z'-'A'+3)*8));
		}
		a++;
	}
	kolumna+=strlen(tekst);

	rysuj_terminal(T1,T2);
	narysuj_obiekt(luf_off,luf_seg,luf_wys+384);
	bufor_na_ekran();
		}
}


char *computer::cyfry[]={"ZERO","ONE","TWO","THREE","FOUR","FIVE",
			"SIX","SEVEN","EIGHT","NINE","TEN"};

char *computer::funkcje[]={
			"EXIT","HELP","COPY","MEMORY","PERSONAL EQUIPMENT",
			// funkcje stale

			"PERSONAL DATA","MISSION TARGET",
			// dodatkowe funkcje komputera cyborga

			"MAP","ALARM SYSTEM INFO","SYSTEM MEMORY",
			// dane o labiryncie Obcych

			"ALIEN BIOLOGY","ALIEN EVOLUTION",
			"ALIEN SOCIETY","ALIEN ART","ALIEN PSYCHOLOGY",
			"ALIEN TECHNICS","ALIEN PHYSICS","ALIEN MATH",
			"ALIEN CHEMISTRY","ALIEN LANGUAGE",
			// informacje o Obcych

			"OPTICAL ANALYSES","ANTIVIRUS","SYSTEM VIRUS",
			"CODE INFO","INSTALL MEMORY","SELF SERVICE",
			// funkcje uzytkowe


			"***"
			};

void computer::run(void)
{
 int i,jest;

 // wpisywanie komend
 do
 {
 jest=0;

 komenda[command()]=0;

 // interpretacja  i wykonywanie komend

 i=0;

  do
  {
   if (strcmp(funkcje[i],komenda)==0) { jest=i+1; }
   i++;
  }
  while (strcmp(funkcje[i],"***")!=0);

 switch (jest)
   {
   case 2 : writeln("NO HELP YET"); break; // help
   case 3 : write("SOURCE "); komenda[command()]=0; break;       // copy
   case 4 : writeln("NORMAL"); break; 	   // memory
   case 5 : writeln("GUN"); break;	   // personal equipment
   case 6 : writeln("ALIEN TERMINATOR"); break; // personal data
   case 7 : writeln("ELIMINATE ALIENS"); break; // mission target

   case 8 : writeln("NO MAP YET"); break; // map
   case 9 : writeln("NO INFO YET"); break; // alarm system info
   case 10 : writeln("UNAVAILABLE"); break; // system memory

   // informacje o Obcych
   case 11 : /* biologia - fizjologia */ break;
   case 12 : /* biologia - ewolucja */ break;
   case 13 : /* socjologia */ break;
   case 14 : /* sztuka */ break;
   case 15 : /* psychologia */ break;
   case 16 : /* technika */ break;
   case 17 : /* nauka - fizyka */ break;
   case 18 : /* nauka - matematyka */ break;
   case 19 : /* nauka - chemia */ break;
   case 20 : /* jezyk Obcych */ break;
   }

   if (!jest) writeln("# WRONG COMMAND");
 }
 while (strcmp(komenda,"EXIT") && (wiersz<ilosc_wierszy));

}




void computer::picture(void)
{
 unsigned x,y;
 int kadr=0,dk=1;

 do
 {
  for (x=0;x<32;x++)
   for (y=0;y<64;y++)
    {
     switch (kadr)
     {
     case 0 :
     setcolor(peekb(glowacz1_seg,glowacz1_off+x+y*32));
     break;
     case -1 :
     setcolor(peekb(glowacz2_seg,glowacz2_off+x+y*32));
     break;
     case 1 :
     setcolor(peekb(glowacz2_seg,glowacz2_off+(31-x)+y*32));
     break;
     }
    plot(x+16,y);
    }

    show_screen();

    kadr+=dk;
    if (kadr==1) dk=-1;
    if (kadr==-1) dk=1;
 }
 while (!kbhit());
 getch();
}

int computer::command(void)
{
 int nr;
 char lit[2]={0,0},znak;

 nr=0;
 // wpisanie slowa
 do
 {
  znak=toupper(getch());
  if (znak==0) getch();
  if (((znak>='A') && (znak<='Z')) || (znak==' '))
	{ komenda[nr++]=znak; lit[0]=znak; write(lit); }
 }
 while ((znak!=13) && (kolumna<ilosc_kolumn));
 writeln();

 return nr;
}





// sesja z wewnetrznym systemem
void sesja(void)
{
unsigned x,y;
unsigned char k;

 nosound();


for (x=8;x<192-8;x++)
 for (y=8;y<130;y++)
  {
  k=bufor[x+y*192];
  bufor[x+y*192]=128+(k%16);
  }

  brain.start();
  brain.writeln("CENTRAL SYSTEM CALL");

  brain.run();

  jest_napis=0;

}


void terminclear(void)
{
 unsigned x,y;
 for (x=0;x<128;x++)
  for (y=0;y<64;y++)
   pokeb(ter_seg,ter_off+x+y*128,0);
}

void alien_session(void)
{
	nosound();
	terminclear();

	alien_term.start();
	alien_term.writeln("ALARM SYSTEM");
	alien_term.run();
}



// zmienne dla procedury rysowania potworow
long dx,dy,maxodl;
int i,ten,j,d,kto_dostal,traf_buf;
punkt *postrzal;


int odrzut=0,autofire=0;


void w_schowku(void)
{
	do
	{
	// wyczysc();
	#include "wyczysc.h"

	// komnata()
	#include "malakom.h"

	// narysuj_potwory();
	#include "naryspot.h"

	nosound();

	if (strzal)
		{
			if (strzal & 1)
			{
			sound(50);
			narysuj_obiekt(ogien_off,ogien_seg,ogien_poz);
			odrzut=384;
			}
			if (autofire) strzal=!strzal; else strzal--;
		}
		else
		{
		if (autofire) strzal=!strzal;
		}

	narysuj_obiekt(luf_off,luf_seg,luf_wys+odrzut); odrzut=0;

	if (jest_napis) {
		if (jest_napis & 2)
			narysuj_obiekt(napis_off,napis_seg,napis_poz);
		jest_napis--;
			}

	// bufor_na_ekran();
	#include "bufnaek.h"

	// czas_biegnie();
	#include "czasbieg.h"

	if (kbhit())
	 {
	 switch (getch())
	 {
	  case 0 :
	  switch (getch())
	  {

	  case 75 : if (turn>-1) turn--;
			if (turn==-1) czas_t=TIME;
			break;
	  case 77 : if (turn<1) turn++;
			if (turn==1) czas_t=TIME;
			break;
	  case 72 : if (go<1) go++;
			if (go==1) czas_g=TIME;
			break;
	  case 80 : if (go>-1) go--;
			if (go==-1) czas_g=TIME;
			break;
	  case 115 : if (side<1) side++;
			if (side==1) czas_s=TIME;
			break;
	  case 116 : if (side>-1) side--;
			if (side==-1) czas_s=TIME;
			break;

	  case 141 : if (strzal<10) strzal+=10; break;
	  case 145 : autofire=1-autofire; jest_napis=20;
			wyczysc_napis();
	  ustaw_napis( autofire ? "AUTOFIRE ON" : "AUTOFIRE OFF");
			break;

	  case 59 : sesja(); break;
	  } break;

	  case 27 : koniec=1; break;
	  }
	 }

	 if (go) switch (go)
			{
			 case 1 : E+=zwrot; mala_granice(); break;
			 case -1 : E-=zwrot; mala_granice(); break;
			}

	 if (side) switch (side)
			{
			 case 1 : E+=bok; mala_granice(); break;
			 case -1 : E-=bok; mala_granice(); break;
			}

	 if (turn) switch (turn)
			{
			 case -1 : direct++;
				if (direct==72) direct=0;
				skrec();
				break;
			 case 1 : direct--;
				if (direct<0) direct=71;
				skrec();
				break;
			}


	 }
	 while (!koniec && !wyjdz);
}




void main(void)
{

	load13h("graf\\mur.a13",&murek);
	load13h("graf\\glowacz.a13",&glowacz1);
	load13h("graf\\glowacz2.a13",&glowacz2);
	load13h("graf\\lufa.a13",&lufa);
	load13h("graf\\ogien.a13",&ogien);
	load13h("graf\\rana.a13",&rana[0]);
	load13h("graf\\rana2.a13",&rana[1]);
	load13h("graf\\rana3.a13",&rana[2]);
	load13h("graf\\alfabet.a13",&alfabet);

	napis=allocimage(0,0,191,7);
	napis[0]=8; napis[1]=0;
	napis[2]=192; napis[3]=0;

	// ekran zewnetrznego terminala
	terminal=allocimage(0,0,127,63);
	terminal[0]=64; terminal[1]=0;
	terminal[2]=128; terminal[3]=0;

	ter_off=FP_OFF(terminal);
	ter_seg=FP_SEG(terminal);


	alf_off=FP_OFF(alfabet);
	alf_seg=FP_SEG(alfabet);

	napis_off=FP_OFF(napis);
	napis_seg=FP_SEG(napis);

	murek_off=FP_OFF(murek)+4;
	murek_seg=FP_SEG(murek);

	glowacz1_off=FP_OFF(glowacz1)+4;
	glowacz1_seg=FP_SEG(glowacz1);

	glowacz2_off=FP_OFF(glowacz2)+4;
	glowacz2_seg=FP_SEG(glowacz2);

	luf_off=FP_OFF(lufa);
	luf_seg=FP_SEG(lufa);

	ogien_off=FP_OFF(ogien);
	ogien_seg=FP_SEG(ogien);

	for (i=0;i<3;i++)
	{
	rana_off[i]=FP_OFF(rana[i]);
	rana_seg[i]=FP_SEG(rana[i]);
	}

	alokuj_bufor();

	oblicz_wektory();


	// wywolanie trybu 13h
	asm {
	push ax
	mov ah,0
	mov al,0x13
	int 0x10
	pop ax
	}



	skrec();

	ax=getmaxx()/2-xekr; bx=ax+2*xekr;
	sy=getmaxy()/2;
	ay=sy-yekr; by=sy+yekr;

	maxx=2*xekr; maxy=2*yekr;



	for (i=0;i<IL_POT;i++)
	 power[i]=10;

	if (jest_bufor)
	{



	przygotuj_ekran();
	przesun=wzor_wys_bit+1;
	przygotuj_bufor();


	// do generowania potworkow
	randomize();


		for (i=0;i<IL_POT;i++)
		{ 	power[i]=10;
			potwor[i].x=random(2800)-1400;
			potwor[i].x<<=dokbit;
			potwor[i].y=random(2800)-1400;
			potwor[i].y<<=dokbit;
		}

	narysuj_obiekt(luf_off,luf_seg,luf_wys+384);


	// przygotuj labirynt
	prepare_meikyu();
	meikyu[labx][laby].come_in();
	meikyu[labx][laby].open_door(0);

	wyczysc_napis();
	ustaw_napis("MISSION BEGINNING");
	jest_napis=40;

	do
	{

	// wyczysc();
	#include "wyczysc.h"

	// komnata()
	#include "komnata.h"

	// narysuj_potwory();
	#include "naryspot.h"

	nosound();

	if (strzal)
		{
			if (strzal & 1)
			{
			sound(50);
			narysuj_obiekt(ogien_off,ogien_seg,ogien_poz);
			odrzut=384;
			}
			if (autofire) strzal=!strzal; else strzal--;
		}
		else
		{
		if (autofire) strzal=!strzal;
		}

	narysuj_obiekt(luf_off,luf_seg,luf_wys+odrzut); odrzut=0;

	if (jest_napis) {
		if (jest_napis & 2)
			narysuj_obiekt(napis_off,napis_seg,napis_poz);
		jest_napis--;
			}

	// bufor_na_ekran();
	#include "bufnaek.h"

	// czas_biegnie();
	#include "czasbieg.h"

	if (kbhit())
	 {
	 switch (getch())
	 {

	  case 0 :
	  switch (getch())
	  {

	  case 75 : if (turn>-1) turn--;
			if (turn==-1) czas_t=TIME;
			break;
	  case 77 : if (turn<1) turn++;
			if (turn==1) czas_t=TIME;
			break;
	  case 72 : if (go<1) go++;
			if (go==1) czas_g=TIME;
			break;
	  case 80 : if (go>-1) go--;
			if (go==-1) czas_g=TIME;
			break;
	  case 115 : if (side<1) side++;
			if (side==1) czas_s=TIME;
			break;
	  case 116 : if (side>-1) side--;
			if (side==-1) czas_s=TIME;
			break;

	  case 141 : if (strzal<10) strzal+=10; break;
	  case 145 : autofire=1-autofire; jest_napis=20;
			wyczysc_napis();
	  ustaw_napis( autofire ? "AUTOFIRE ON" : "AUTOFIRE OFF");
			break;

	  case 59 : sesja(); break;
	  case 60 :
		if ((strzal==0) && (autofire==0))
		{
		nosound();
		alien_session();
		}
		break;

	  case 61 :
		for (i=0;i<IL_POT;i++)
		{ 	power[i]=10;
			potwor[i].x=random(2800)-1400;
			potwor[i].x<<=dokbit;
			potwor[i].y=random(2800)-1400;
			potwor[i].y<<=dokbit;
		}
		akt_il_pot=IL_POT; break;

	  case 62 : otwarte=0; granice(); break;
	  case 63 : if (E.x>otwieraj) otwarte=2;
		    if (E.x<-otwieraj) otwarte=4;
		    if (E.y>otwieraj) otwarte=1;
		    if (E.y<-otwieraj) otwarte=3;
		    sasiad=meikyu[labx][laby].open_door(otwarte);
		    break;
	  } break;

	  case 27 : koniec=1; break;
	 }
	 }

	 if (go) switch (go)
			{
			 case 1 : E+=zwrot; granice(); break;
			 case -1 : E-=zwrot; granice(); break;
			}

	 if (side) switch (side)
			{
			 case 1 : E+=bok; granice(); break;
			 case -1 : E-=bok; granice(); break;
			}

	 if (turn) switch (turn)
			{
			 case -1 : direct++;
				if (direct==72) direct=0;
				skrec();
				break;
			 case 1 : direct--;
				if (direct<0) direct=71;
				skrec();
				break;
			}


	 }
	 while (!koniec);
	}

	// powrot
	asm {
	push ax
	mov ah,0
	mov al,0x03
	int 0x10
	pop ax
	}

	nosound();


	farfree(bufor);
	freeimage(&murek);
	freeimage(&glowacz1);
	freeimage(&glowacz2);
	freeimage(&lufa);
	freeimage(&ogien);
	freeimage(&terminal);
	freeimage(&alfabet);
	freeimage(&napis);

	for (i=0;i<3;i++) freeimage(rana+i);
}