
#include <malloc.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <io.h>




unsigned char far *allocimage(int,int,int,int);
void freeimage(unsigned char far **);
void load13h(char *,unsigned char far **);
unsigned imagewidth(unsigned char far *);
unsigned imageheight(unsigned char far *);
unsigned imagelength(unsigned char far *);

unsigned imagewidth(unsigned char far *heli)
{
 unsigned dx;
 dx=heli[3]; dx*=256; dx+=heli[2];
 return dx;
}

unsigned imageheight(unsigned char far *heli)
{
 unsigned dx;
 dx=heli[1]; dx*=256; dx+=heli[0];
 return dx;
}

unsigned imagelength(unsigned char far *heli)
{
 return imagewidth(heli)*imageheight(heli)+4;
}

void load13h(char *n,unsigned char far **wskaznik)
{
unsigned linia,wysokosc,dlug;
unsigned char *mapa;
int handle;


handle=open(n,O_BINARY,S_IREAD);


 if (handle!=-1)
 {
 read(handle,&dlug,sizeof dlug);

 read(handle,&wysokosc,2);
 read(handle,&linia,2);


 *wskaznik=allocimage(0,0,wysokosc-1,linia-1);

 mapa=*wskaznik;

 if (mapa!=NULL)
 {

 mapa[0]=wysokosc & 255;
 mapa[1]=wysokosc >> 8;
 mapa[2]=linia & 255;
 mapa[3]=linia >> 8;

 read(handle,mapa+4,dlug-4);
 }

 close(handle);
 }
}

unsigned char far *allocimage(int x1,int y1,int x2,int y2)
{
unsigned char far *wynik;
unsigned long dlugosc;
dlugosc=x2-x1+1; dlugosc*=y2-y1+1;
wynik=(unsigned char far *)farmalloc(dlugosc+4);
return wynik;
}

void freeimage(unsigned char far **wzor_ptr)
{
 if (*wzor_ptr!=NULL)
  {
 farfree(*wzor_ptr);
 *wzor_ptr=NULL;
  }
}
